/*
	$Id: Resource.h,v 1.4 2004/04/10 20:56:31 syl Exp $

	Copyright (C) 1998, 1999 Syllabub
	Maroontress Fast Software.
*/

typedef struct {
    const char *name;
    const char *class;
    const char *orig;
    const char *spec;
} SylSetting;

typedef struct SylKeymap {
    unsigned int mod;
    unsigned int func;
    struct SylKeymap *next;
} SylKeymap;

typedef struct {
    XFontSet id;
    int width;
    int height;
    int ascent;
    int descent;
    int tabsep;
} SylFontSet;

XrmDatabase SylMergedResourceDatabase(Display *);
void GetSylSetting(Display *, const char *, const char *, SylSetting *);

/*XXX*/ int FQLength(const char *, const char *c);
/*XXX*/ void FQCompose(const char *, const char *, char *);
/*XXX*/ void SetFQClassHint(Display *, Window, const char *, const char *,
			    Window);

void LoadSylColors(Display *, char *, char *, SylSetting **, unsigned long *);
unsigned long * CreateSylColors(SylSetting **);
void FreeSylColors(unsigned long *);

void LoadSylKeymap(Display *, const char *, const char *,
		   SylSetting **, SylKeymap **);
SylKeymap ** CreateSylKeymap(void);
void FreeSylKeymap(SylKeymap **);

XFontSet CreateSylFontSet(Display *, const char *, SylFontSet *);
void FreeSylFontSet(Display *, SylFontSet *);
#ifdef DEBUG
void StatSylFontSet(void);
#endif
void CleanupSylFontSet(void);
void LoadSylFontSets(Display *, const char *, const char *,
		     SylSetting **, SylFontSet *);

void LoadSylIMStyles(Display *, const char *, const char *,
		     SylSetting **, XIMStyle *);

void LoadSylGravities(Display *, const char *, const char *,
		      SylSetting **, int *);
int Syl_X(int parent_width, int width, int gravity);
int Syl_Y(int parent_height, int height, int gravity);

#ifdef PASSIVE_FOCUS_MODEL
#define XSetInputFocus SylSetInputFocus
void SylSetInputFocus(Display *, Window, int, Time);
void SylSendKeyEvent(XKeyEvent *);
#endif
