/*
	$Id: Text.h,v 1.2 2003/11/11 16:20:05 syl Exp $

	Copyright (C) 1999, 2000 Syllabub
	Maroontress Fast Software.
*/

typedef struct {
    wchar_t *wcs; /* 磻ɥ饯ʸ */
    int len;      /* ʸ */
    int eol;      /* End Of Line (True or False) */
} SylText;

#define LengthOfSylText(t) ((t)->len)
#define EndOfLineSylText(t) ((t)->eol)

SylText * CreateSylTextFromMBString(const char *mbs, int eol);
SylText * CreateSylTextFromWCString(const wchar_t *wcs, int eol);
void FreeSylText(SylText *txt);
SylText * DuplicateSylText(SylText *txt);
wchar_t * CreateWCStringFromSylText(SylText *txt, int bgn, int end);
wchar_t * CreateWCStringFromSylText0(SylText *txt);
char * CreateMBStringFromSylText(SylText *txt, int bgn, int end);
char * CreateMBStringFromSylText0(SylText *txt);
int InsertWCharIntoSylText(SylText *txt, int n, wchar_t c);
int InsertWCStringIntoSylText(SylText *txt, int n, const wchar_t *p);
int InsertSylTextIntoSylText(SylText *txt, int offset, SylText *sub,
			     int begin, int end);
int InsertSylTextIntoSylText0(SylText *txt, int offset, SylText *sub);
void DeleteCharOfSylText(SylText *txt, int n);
void DeleteStringOfSylText(SylText *txt, int bgn, int end);
void ChangeEndOfLineSylText(SylText *txt, int eol);
int CompareSylText(SylText *, SylText *);
int GetCharPositionInSylText(SylText *txt, int bgn, int end, wchar_t c);
int GetCharPositionInSylText0(SylText *txt, wchar_t c);
void ReplaceCharOfSylText(SylText *txt, int n, wchar_t c);
wchar_t GetCharOfSylText(SylText *txt, int n);

SylText * ConcatAndCreateSylText(SylText *head, SylText *tail);
void SplitAndCreateSylTexts(SylText *txt, int n, int eol,
			    SylText **head, SylText **tail);

int SylTextEscapement(XFontSet fs, SylText *txt, int bgn, int end);
int SylTextEscapement0(XFontSet fs, SylText *txt);
void DrawSylText(Display *disp, Drawable d, XFontSet fs, GC gc, int x, int y,
		 SylText *txt, int begin, int end);
void DrawSylText0(Display *disp, Drawable d, XFontSet fs, GC gc, int x, int y,
		  SylText *txt);
void DrawImageSylText(Display *disp, Drawable d, XFontSet fs, GC gc,
		      int x, int y, SylText *txt, int begin, int end);
void DrawImageSylText0(Display *disp, Drawable d, XFontSet fs, GC gc,
		       int x, int y, SylText *txt);

/*
  SylText * CreateSylTextFromMBString(mbs, eol):
  SylText * CreateSylTextFromWCString(wcs, eol):
  char *mbs;
  wchar_t *Wcs;
  int eol;

  ؿCreateSylTextFromMBString()ϥޥХʸmbsɽƥȤ
  롣
  
  ؿCreateSylTextFromWCString()ϥ磻ɥ饯ʸwcsɽƥ
  Ȥ롣
  
  ޥХʸmbsӥ磻ɥ饯ʸwcsϡ̥ʸǽü
  ƤʤФʤʤ

  eolˤƥȤŪʹĤɤꤹ롣eol
  TrueξϹFalseξϹ⤿ʤƥȤ塢
  ؿChangeEndOfLineSylText()ƤӽФʤ¤ꡢιλ꤬ѹ
  뤳ȤϤʤ

  δؿϡƥȤǤʤNULL֤ǤʤС
  ƥȤ֤ƥȤפˤʤäϡؿ
  FreeSylText()ǲʤФʤʤޥХʸmbs磻ɥ
  饯ʸwcsƥȤϡѹƤ⡢¾˱
  ڤܤʤ
*/

/*
  void FreeSylText(txt):
  SylText *txt;

  ؿFreeSylText()ϥƥtxt롣
*/

/*
  wchar_t * CreateWCStringFromSylText(txt, begin, end):
  wchar_t * CreateWCStringFromSylText0(txt):
  char * CreateMBStringFromSylText(txt, begin, end):
  char * CreateMBStringFromSylText0(txt):
  SylText *txt;
  int begin;
  int end;

  ؿCreateWCStringFromSylText()ϥƥtxtbeginʸܤendʸ
  ľޤǤɽ磻ɥ饯ʸ롣

  ؿCreateWCStringFromSylText0()ϥƥtxtɽ磻ɥ饯ʸ
  롣
  
  ؿCreateMBStringFromSylText()ϥƥtxtbeginʸܤendʸ
  ľޤǤɽޥХʸ롣
  
  ؿCreateMBStringFromSylText0()ϥƥtxtɽޥХʸ
  롣
  
  δؿϡʸǤʤNULL֤ǤʤС
  ʸ֤ʸϥ̥ʸǽüƤ롣
  ʸפˤʤäϡfree()ǲʤФʤʤƥ
  txtʸϡѹƤ⡢¾˱ƶڤܤʤ
*/

/*
  SylText * DuplicateSylText(txt):
  SylText * ConcatAndCreateSylText(head, tail):
  SylText *txt;
  SylText *head;
  SylText *tail;

  ؿDuplicateSylText()ϥƥtxtʣ롣

  ؿConcatAndCreateSylText()ϥƥheadȥƥtailϢ뤷
  ƥȤ롣ƥȤι̵ͭϡƥ
  tailι̵ͭʤ롣

  δؿϡƥȤǤʤNULL֤ǤʤС
  ƥȤ֤ƥȤפˤʤäϡؿ
  FreeSylText()ǲʤФʤʤƥtxt, head, tail
  ƥȤϡѹƤ⡢¾˱ƶڤܤʤ
*/

/*
  void SplitAndCreateSylTexts(txt, offset, eol, head, tail):
  SylText *txt;
  int offset;
  int eol;
  SylText **head;
  SylText **tail;

  ؿSplitAndCreateSylTexts()ϥƥtxtƬoffsetʸܤľ
  ޤǤɽƥheadȡoffsetʸܤ齪üޤǤɽƥtail
  롣ƥheadι̵ͭeolǻꤵ졢ƥtailι
  ̵ͭϥƥtxtι̵ͭʤ롣

  ƥheadޤϥƥtailǤʤϡ줾NULL֤
  ǤʤС줾ƥȤ֤ƥȤ
  ˤʤäϡFreeSylText()ǲʤФʤʤƥtxt
  ƥhead, tailϡѹƤ⡢¾˱ƶڤܤ
  ʤ
*/

/*
  int InsertSylTextIntoSylText(txt, offset, sub, begin, end);
  int InsertSylTextIntoSylText0(txt, offset, sub);
  int InsertWCharIntoSylText(txt, offset, wc);
  int InsertWCStringIntoSylText(txt, offset, wcs);
  SylText *txt;
  int offset;
  SylText *sub;
  int begin;
  int end;
  wchar_t wc;
  wchar_t *wcs;

  ؿInsertSylTextIntoSylText()ϥƥsubbeginʸܤendʸ
  ľޤǤ򡢥ƥtxtoffsetʸܤ롣

  ؿInsertSylTextIntoSylText0()ϥƥsub򡢥ƥtxtoffsetʸ
  ܤ롣

  ؿInsertWCharIntoSylText()ϥ磻ɥ饯wcƥtxt
  offsetʸܤ롣

  ؿInsertWCStringIntoSylText()ϥ磻ɥ饯ʸwcsƥ
  txtoffsetʸܤ롣磻ɥ饯ʸwcsϥ̥ʸǽü
  ƤʤФʤʤ

  δؿTrue򡢼ԤFalse֤Ԥ
  硢ƥtxtϤޤäѹʤƥtxtȥƥsub
  ޤϥƥtxtȥ磻ɥ饯ʸpϡ˰ѹ
  Ƥ⡢¾˱ƶڤܤʤ
*/

/*
  void DeleteCharOfSylText(txt, offset):
  void DeleteStringOfSylText(txt, begin, end):
  SylText *txt;
  int offset;
  int begin;
  int end;

  ؿDeleteCharOfSylText()ϥƥtxtoffsetʸܤõ롣

  ؿDeleteStringOfSylText()ϥƥtxtbeginʸܤendʸܤľ
  ޤǤõ롣

  δؿϡΥƥȤ礦ɼޤ륵Υ򿷤
  ݤ褦Ȥ롣ݤǤϡݤƤΰ
  ݤΰѤ롣ݤǤʤäϡϲ񤹤뤬
  ݤƤΰѤ롣
*/

/*
  void ChangeEndOfLineSylText(txt, eol):
  int EndOfLineSylText(txt):
  SylText *txt;
  int eol;

  ؿChangeEndOfLineSylText()ϥƥtxtŪʹξ֤eol
  TrueξϹĤ褦ˡFalseξϹ⤿ʤ褦ѹ
  롣

  ޥEndOfLineSylText()ϥƥtxtŪʹξ֤֤
  ͤTrueξϹFalseξϹ⤿ʤȤɽ
*/

/*
  int CompareSylText(txt1, txt2):
  int LengthOfSylText(SylText *txt):
  SylText *txt1;
  SylText *txt2;
  SylText *txt;

  ؿCompareSylText()ϥƥtxt1txt2ɽʸ򡢼Ū
  Ӥ롣txt1txt2礭硢txt2硢txt2⾮
  硢줾0֤ӤκݡŪʹͭ
  ̵ͤ˱ƶʤ

  ޥLengthOfSylText()ϥƥtxtɽʸĹ֤Ū
  ̵ͭͤ˱ƶʤ
*/
